+++
title = 'Коротко о разработке ПО сейчас'
date = 2023-11-04T11:10:32+04:00
draft = false
tags = ['перевод']
+++

Представим, что я решил сделать подставку для специй.

Я уже имел дело с небольшими проектами по работе с деревом, и хорошо представляю, что мне необходимо: древесный материал и несколько основных инструментов: рулетка, уровень, пила и молоток.

Если бы я строил дом, а не простую подставку, мне бы всё равно, помимо прочего, пригодились рулетка, уровень, пила и молоток.

Итак, я иду в строительный магазин за инструментами и спрашиваю у продавца, где бы я мог взять молоток.

— Молоток? — переспрашивает он. — Их больше никто не покупает, это же такое старьё.

Удивлённый таким поворотом событий, я спрашиваю, почему.

— Проблема в том, что слишком много разных видов молотков: кувалда, гвоздодёр, молоток с круглым бойком... Что, если вы возьмёте один молоток, а через некоторое время поймёте, что вам нужен другой? Придётся купить новый инструмент. Выяснилось, что большинству людей нужен один-единственный молоток, способный выполнять все возможные задачи.

— Хм, ну хорошо, звучит разумно. Так где я могу приобрести универсальный молоток?

— Мы их больше не продаём, они уже устарели.

— Да? Мне показалось, вы только что говорили, что будущее за универсальным молотком.

— Как оказалось, если мы создаём молоток, выполняющий все задачи разных видов молотков, он их выполняет не очень хорошо. Выдёргивать гвоздь кувалдой неэффективно. Да и при желании убить кого-то молот с круглым бойком — незаменимый инструмент.

— Верно. Так если универсальные молотки никому не нужны, и вы не продаёте старые образцы, тогда какие молотки вы вообще продаёте?

— Никакие. Совсем.

— А...

— По результатам наших исследований, то, что действительно нужно людям — далеко не универсальный молоток. Всегда лучше для конкретной работы использовать конкретный вид молотка. Поэтому мы стали продавать фабрики, способные производить все виды молотков, какие вам только ни потребуются. Достаточно лишь привлечь сотрудников, запустить механизмы, купить материалы, оплатить счета и... вуаля! В мгновение ока вы получаете тот самый молоток.

— Но мне не нужна фабрика...

— Вот и хорошо, ведь мы их больше не продаём.

— Мне показалось, вы только что говорили...

— Мы поняли, что большинству людей не нужна целая фабрика. Некоторым, например, никогда не потребуется молот с круглым бойком (может, им не надо никого убивать, или они уже убили кого надо, используя нож для колки льда вместо молота). Так что покупка фабрики, производящей каждый вид молотка, не имеет смысла.

— В этом есть доля правды.

— Поэтому мы начали продавать чертежи для фабрик молотков, позволяя клиентам создавать свои фабрики, спроектированные специально под конкретный вид молотка, который им действительно нужен.

— Дайте угадаю, вы их тоже больше не продаёте.

— Нет, конечно же не продаём. Оказалось, люди не хотят создавать целую фабрику ради того, чтобы произвести пару молотков. Я всегда говорю: "Оставьте строительство фабрик специалистам по строительству фабрик!"

— И тут я с вами соглашусь.

— Ага. Поэтому мы перестали реализовывать чертежи и начали продавать фабрики по постройке фабрик молотков. Каждая фабрика фабрик создаётся нашими лучшими экспертами в бизнесе фабрик фабрик молотков, так что вам даже не нужно вдаваться в подробности постройки фабрик. И вы всё ещё получаете те же преимущества своей фабрики, спроектированной на ваше усмотрение, выпускающей молотки на ваш вкус, в соответствии с вашим дизайном и чертежами.

— Но это не то, что мне...

— Я знаю, что вы хотите сказать! И мы их тоже больше не продаём. По некоторым причинам не так много людей покупали фабрики фабрик молотков, так что мы разработали новый вариант для решения этой проблемы.

— Внимательно слушаю.

— Мы шагнули назад, посмотрели на картину инфраструктуры строительных инструментов целиком и определили, что люди разочарованы в необходимости управлять фабрикой фабрик, как и производимой ею фабрикой. Это довольно обременительно, когда вы оперируете по такому же сценарию ещё и фабрикой фабрик рулеток, фабрикой фабрик уровней, фабрикой фабрик пил, не говоря уже о холдинге компаний по производству древесного материала. После здравой оценки ситуации стало ясно, что вышеописанное слишком сложно для тех, кому просто хочется сделать подставку для специй.

— Да, без шуток, абсолютно верно.

— Поэтому на этой неделе мы представляем фабрику фабрик фабрик общего назначения по производству инструментов, так что теперь все ваши фабрики могут быть произведены всего одной, универсальной фабрикой! Фабрика фабрик фабрик производит только фабрики фабрик тех инструментов, которые вам действительно нужны, и каждая из этих фабрик фабрик производит только одну фабрику на основе ваших спецификаций строительного инструмента. Окончательный набор инструментов, полученный из этого процесса, будет идеальным набором для вашего проекта. У вас есть тот самый молоток, та самая рулетка, подходящая под задачу. Всё одним нажатием кнопки (но скорее всего придётся написать пару конфигурационных файлов, чтобы всё работало в соответствии с вашими предпочтениями).

— То есть у вас нету молотков? Совсем?

— Нет. Если вы хотите получить высококачественную, индустриально спроектированную подставку для специй, вам точно нужно что-то более профессиональное, чем простой молоток из какого-то магазинчика.

— И так все сейчас делают? Все пользуются фабрикой фабрик фабрик общего назначения по производству инструментов, когда им нужен молоток?

— Всё верно.

— Ну хорошо. Раз уж так сейчас делают, лучше научиться этому.

— Что будет очень полезно для вас!

— У этой штуки же есть документация, да?

***

_[Оригинальный текст](https://factoryfactoryfactory.net) написан Benji Smith,_  
_переведён [DarkCat09](https://dc09.ru)_
