+++
title = 'Переустановка, приватный Piped'
date = 2023-11-05T14:16:17Z
draft = false
+++

[In English](/posts/reinstall-23)

На 06.11.2023 запланирована очередная переустановка сервера (создание нового VPS с переносом всех данных) из-за:
1. блокировки IP-адреса ютубом
2. не совсем удобной для администрирования архитектуры

Постараюсь предоставить максимальную доступность сервисов, старая и новая VPSка будут запущены параллельно до полного переноса и проверки.

Дистрибутив не меняется, Alpine Linux Virtual. Но теперь софт будет компилироваться на моём домашнем ПК, а не на сервере, что было очень неэффективно и нагружало рабочий сервер.

Безопасность:
- Не будет установлен `qemu-guest-agent`: рекомендован Таймвэбом для управления из веб-панели, но при обширном функционале по сути является бэкдором.
- Будет отключено проксирование через Cloudflare для большинства доменов.
- TLS-сертификаты от Let's Encrypt.

Публичность / invite-only:
- Доступ к Piped предоставляется *только* по просьбе, так как сервер не выдерживает текущую нагрузку в том числе ввиду проблем оптимизации джавы.
- Invidious остаётся публичным, но регистрация новых пользователей закрыта.
- Как и раньше, доступ к Shlink, SFTPGo и почтовому серверу — по просьбе.
- Со мной можно связаться либо [по почте](mailto:cat@dc09.ru), либо [через тг](https://t.me/darkcat09); пишите, куда выдать доступ, и желаемый юзернейм для аккаунта.
